task BQSR {
  
  File ref_dir
  File dbsnp_dir
  File dbmills_dir
  
  String sample
  String SENTIEON_INSTALL_DIR
  String SENTIEON_LICENSE
  String fasta
  String dbsnp
  String db_mills
  File deduped_bam
  File deduped_bam_index
  String docker
  String cluster_config
  String disk_size

  command <<<
    set -o pipefail
    set -e
    export SENTIEON_LICENSE=${SENTIEON_LICENSE}
    nt=$(nproc)

    ${SENTIEON_INSTALL_DIR}/bin/sentieon driver -t $nt \
    -r ${ref_dir}/${fasta} -i ${deduped_bam} \
    --algo QualCal \
    -k ${dbsnp_dir}/${dbsnp} -k ${dbmills_dir}/${db_mills} \
    ${sample}_recal_data.table
  >>>

  runtime {
    docker: docker
    cluster: cluster_config
    systemDisk: "cloud_ssd 40"
    dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"  
  }

  output {
    File recal_table = "${sample}_recal_data.table"
  }
}
